(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("jQuery"));
	else if(typeof define === 'function' && define.amd)
		define("vis-requestor", ["jQuery"], factory);
	else if(typeof exports === 'object')
		exports["vis-requestor"] = factory(require("jQuery"));
	else
		root["vis-requestor"] = factory(root["jQuery"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_2__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _util = __webpack_require__(1);
	
	var _util2 = _interopRequireDefault(_util);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var defaultOpt = {
	  onSessionExpired: function onSessionExpired() {},
	  ajaxOption: {
	    method: 'POST'
	  },
	
	  resultCode: {
	    SESSION_EXPIRED: Symbol(),
	    SUCCEED: Symbol()
	  },
	
	  urlOption: {
	    base: '',
	    port: '',
	    host: ''
	  },
	
	  alert: function alert(msg) {
	    // window.alert(msg)
	    console.log(msg);
	  },
	
	  failedMsg: ''
	};
	
	function requestor(jquery, globalOpt) {
	  globalOpt = Object.assign(defaultOpt, globalOpt);
	
	  globalOpt.ajaxOption.dataType = 'json';
	
	  var asyncAlert = function asyncAlert(msg) {
	    if (!msg) return;
	    setTimeout(function () {
	      globalOpt.alert(msg);
	    }, 0);
	  };
	
	  function request(option) {
	    return new Promise(function (resolve, reject) {
	      jquery.ajax(option).then(function (res, status, xhr) {
	        var code = res.code;
	
	        if (code === globalOpt.resultCode.SUCCEED) {
	          resolve(res.result, code, xhr, res);
	        } else {
	          // failed
	          if (code === globalOpt.resultCode.SESSION_EXPIRED) {
	            globalOpt.onSessionExpired();
	          }
	
	          reject(res);
	          asyncAlert(res.msg);
	        }
	      }, function (xhr) {
	        reject(xhr);
	        asyncAlert(globalOpt.failedMsg);
	      });
	    });
	  }
	
	  function requestAPI(apiOption) {
	    var currOption = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
	
	    var option = _util2.default.mergeAjaxOption(globalOpt.ajaxOption, apiOption, currOption);
	
	    option.url = _util2.default.normalizeUrl(option.url, option.query, globalOpt.urlOption);
	    delete option.query;
	
	    if (option.contentType && option.contentType.indexOf('application/json') !== -1) {
	      _util2.default.stringifyData(option.data);
	    }
	
	    return request(option);
	  }
	
	  return {
	    request: request,
	    requestAPI: requestAPI
	  };
	}
	
	exports.default = requestor;

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	Object.defineProperty(exports, "__esModule", {
	  value: true
	});
	
	var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };
	
	var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };
	
	var _jquery = __webpack_require__(2);
	
	var _jquery2 = _interopRequireDefault(_jquery);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var HTTP_PROTOCOL = /^http[s]?:\/\//;
	
	function normalizeUrl(url, query, option) {
	  if (HTTP_PROTOCOL.test(url)) return url;
	
	  var fullUrl = option.host || '';
	
	  if (option.port) {
	    fullUrl += option.port ? ':' + option.port : '';
	  }
	
	  if (option.base) {
	    fullUrl += option.base;
	  }
	
	  fullUrl += url;
	
	  if (query) {
	    var connChar = fullUrl.indexOf('?') === -1 ? '?' : '&';
	    fullUrl += connChar + _jquery2.default.param(query);
	  }
	
	  return fullUrl;
	}
	
	function mergeAjaxOption() {
	  for (var _len = arguments.length, options = Array(_len), _key = 0; _key < _len; _key++) {
	    options[_key] = arguments[_key];
	  }
	
	  var option1 = options.shift();
	  var option2 = options.shift();
	
	  var query = _extends({}, option1.query, option2.query);
	  var data = _extends({}, option1.data, option2.data);
	  var headers = _extends({}, option1.headers, option2.headers);
	
	  var mergedResult = _extends({}, option1, option2, {
	    query: query,
	    data: data,
	    headers: headers
	  });
	
	  if (options.length) {
	    options.unshift(mergedResult);
	    return mergeAjaxOption.apply(undefined, options);
	  } else {
	    return mergedResult;
	  }
	}
	
	function stringifyData(data) {
	  for (var p in data) {
	    var dp = data[p];
	    if ((typeof dp === 'undefined' ? 'undefined' : _typeof(dp)) === 'object' && dp !== null) {
	      data[p] = JSON.stringify(dp);
	    }
	  }
	}
	
	exports.default = {
	  normalizeUrl: normalizeUrl,
	  mergeAjaxOption: mergeAjaxOption,
	  stringifyData: stringifyData
	};

/***/ },
/* 2 */
/***/ function(module, exports) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_2__;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=vis-requestor.js.map